/**
 * @file
 * VuoList_VuoLeapPointableType C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoLeapPointableType_H
#define VuoList_VuoLeapPointableType_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoLeapPointableType VuoList_VuoLeapPointableType
 * A list of @ref VuoLeapPointableType elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoLeapPointableType
 * A list of @ref VuoLeapPointableType elements.
 */
#ifndef VuoList_VuoLeapPointableType_TYPE_DEFINED
typedef void * VuoList_VuoLeapPointableType;
#endif

/**
 * Creates a new list of @ref VuoLeapPointableType elements.
 */
VuoList_VuoLeapPointableType VuoListCreate_VuoLeapPointableType(void);

/**
 * Returns the @ref VuoLeapPointableType at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoLeapPointableType VuoListGetValueAtIndex_VuoLeapPointableType(const VuoList_VuoLeapPointableType list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoLeapPointableType(VuoList_VuoLeapPointableType list, const VuoLeapPointableType value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoLeapPointableType(VuoList_VuoLeapPointableType list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoLeapPointableType(VuoList_VuoLeapPointableType list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoLeapPointableType(const VuoList_VuoLeapPointableType list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoLeapPointableType VuoList_VuoLeapPointableType_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoLeapPointableType_jsonFromValue(const VuoList_VuoLeapPointableType value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoLeapPointableType_summaryFromValue(const VuoList_VuoLeapPointableType value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoLeapPointableType VuoList_VuoLeapPointableType_valueFromString(const char *str);
char * VuoList_VuoLeapPointableType_stringFromValue(const VuoList_VuoLeapPointableType value);
/// @}

/**
 * @}
 */

#endif
