/**
 * @file
 * VuoList_VuoMouseButton C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoMouseButton_H
#define VuoList_VuoMouseButton_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoMouseButton VuoList_VuoMouseButton
 * A list of @ref VuoMouseButton elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoMouseButton
 * A list of @ref VuoMouseButton elements.
 */
#ifndef VuoList_VuoMouseButton_TYPE_DEFINED
typedef void * VuoList_VuoMouseButton;
#endif

/**
 * Creates a new list of @ref VuoMouseButton elements.
 */
VuoList_VuoMouseButton VuoListCreate_VuoMouseButton(void);

/**
 * Returns the @ref VuoMouseButton at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoMouseButton VuoListGetValueAtIndex_VuoMouseButton(const VuoList_VuoMouseButton list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoMouseButton(VuoList_VuoMouseButton list, const VuoMouseButton value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoMouseButton(VuoList_VuoMouseButton list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoMouseButton(VuoList_VuoMouseButton list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoMouseButton(const VuoList_VuoMouseButton list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoMouseButton VuoList_VuoMouseButton_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoMouseButton_jsonFromValue(const VuoList_VuoMouseButton value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoMouseButton_summaryFromValue(const VuoList_VuoMouseButton value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoMouseButton VuoList_VuoMouseButton_valueFromString(const char *str);
char * VuoList_VuoMouseButton_stringFromValue(const VuoList_VuoMouseButton value);
/// @}

/**
 * @}
 */

#endif
